# polygon loop
# Petr Zloty
# petr.zloty@gmail.com
# Version 0.1 released
# 3.9.2007

from win32com.client import constants as c

xsi = Application
log = xsi.logmessage

def TempPPG():
	oRoot =  xsi.ActiveProject.ActiveScene.Root
	oCP = XSIFactory.CreateObject("CustomProperty")
	oCP.Name = "LoopPolyPop"
	oCP.AddParameter2("stepVal", c.siInt2, 2, 2, None, 2, 20, 0, 4, "Step")
	oCP.AddParameter2("selCheckb", c.siBool, False, None, None, None, None, 0, 4, "Select (off) / deselect (on)")

	oLayout = oCP.PPGLayout
	oLayout.Clear()

	oItem = oLayout.AddItem( "stepVal")
	oItem = oLayout.AddItem( "selCheckb")
	oLayout.Language = "PythonScript"

	bCancelled = xsi.InspectObj(oCP,"", "Step",  c.siModal, False)

	if (bCancelled == False):
		step = oCP.stepVal.Value
		Checkb = oCP.selCheckb.Value
		return [step, Checkb]
	else:
		return None

def LoopPoly(oSel, step):
	if oSel == None:
		return False

	try:	
		oOldColl = oSel(0).subcomponent.componentcollection
	except:
		oOldColl = XSIFactory.CreateObject("XSI.Collection")
		for oItem in oSel:
			oOldColl.Add(oItem)
			
	oNewColl = XSIFactory.CreateObject("XSI.Collection")
	
	xsi.RemoveFromSelection(oOldColl)
	i = 0
	while i < oOldColl.count:
		oNewColl.add(oOldColl(i))
		i += step
	xsi.SelectObj(oNewColl)
	return True
	
def LoopPolyDes(oSel, step):
	if oSel == None:
		return False
	
	try:
		oOldColl = oSel(0).subcomponent.componentcollection
	except:
		oOldColl = oSel
	oNewColl = XSIFactory.CreateObject("XSI.Collection")
	for oItem in oOldColl:
		oNewColl.Add(oItem)
		
	i = 0
	while i < oOldColl.count:
		oNewColl.Remove(oOldColl(i))
		i += step
	xsi.SelectObj(oNewColl)
	return True

# main 
oSel = xsi.selection
step = TempPPG()
if step != None:
	if (step[1]):
		LoopPolyDes(oSel, step[0])
	else:
		LoopPoly(oSel, step[0])